View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.filter.codec.statemachine;
    21
    22  import org.apache.mina.core.buffer.IoBuffer;
    23  import org.apache.mina.core.session.IoSession;
    24  import org.apache.mina.filter.codec.ProtocolDecoderOutput;
    25
    26  /**
    27   * Represents a state in a decoder state machine used by
    28   * {@link DecodingStateMachine}.
    29   *
    30   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    31   */
    32  public interface DecodingState {
    33      /**
    34       * Invoked when data is available for this state.
    35       *
    36       * @param in the data to be decoded.
    37       * @param out used to write decoded objects.
    38       * @return the next state if a state transition was triggered (use
    39       *         <code>this</code> for loop transitions) or <code>null</code> if
    40       *         the state machine has reached its end.
    41       * @throws Exception if the read data violated protocol specification.
    42       */
    43      DecodingState decode(IoBuffer in, ProtocolDecoderOutput out) throws Exception;
    44
    45      /**
    46       * Invoked when the associated {@link IoSession} is closed. This method is
    47       * useful when you deal with protocols which don't specify the length of a
    48       * message (e.g. HTTP responses without <tt>content-length</tt> header).
    49       * Implement this method to process the remaining data that
    50       * {@link #decode(IoBuffer, ProtocolDecoderOutput)} method didn't process
    51       * completely.
    52       *
    53       * @param out used to write decoded objects.
    54       * @return the next state if a state transition was triggered (use
    55       *         <code>this</code> for loop transitions) or <code>null</code> if
    56       *         the state machine has reached its end.
    57       * @throws Exception if the read data violated protocol specification.
    58       */
    59      DecodingState finishDecode(ProtocolDecoderOutput out) throws Exception;
    60  }